#!/usr/bin/perl -w
use strict;
use warnings;



my(@infile, $outfile);
my @name_to_print;
my($out);
my($format);
my(@sequences, @seq_names, @new_seqs, @organism_in, @counts_in, @split_line);
my($i, $q, $j, $count,$w) = (0,0,0,0,0);
my($type,$line);


@infile = <*.txt>;
$q = 0;
while($q < scalar(@infile))
{
	unless(open(IN, $infile[$q]))
	{
		print STDERR "Cannot open $outfile!!\n";
		exit;
	}

	if($q == 0)
	{
		my @array_out_1 = split(/\./,$infile[$q]);
		my @array_out_2 = split(/\_/,$array_out_1[0]);
		my $long_out = scalar(@array_out_2);
		if($array_out_2[$long_out - 1] eq 'prof4')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Fam_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof5')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Gen_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof1')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Phylum_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof2')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Class_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof3')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Order_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof6')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Sp_resume.out2';
		}
		elsif($array_out_2[$long_out - 1] eq 'prof7')
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_SubSp_resume.out2';
		}
		elsif(($array_out_2[$long_out - 1] eq 'NoHit')||($array_out_2[$long_out - 1] eq 'Organismos'))
		{
			$outfile = $array_out_2[0] . '_' . $array_out_2[1] . '_percentage_Strain_resume.out2';
		}
		unless(open(OUT, ">$outfile"))
		{
			print STDERR "Cannot open $outfile!!\n";
			exit;
		}
		$name_to_print[$q] = $array_out_2[0] . '_' . $array_out_2[1] . '_' . $array_out_2[2];
		@organism_in =();
		@counts_in = ();
		$count = 0;
		while(<IN>)
		{
			$line =$_;
			chomp $line;
			@split_line =();
			if($count > 0)
			{
				@split_line = split(/\t+/, $line);
				$organism_in[$i] = $split_line[0];
				$counts_in[$i] = $split_line[1];
				$i += 1;
			}
			$count += 1;
		}
	}
	else
	{
		$count = 0;
		my @array_out_1 = split(/\./,$infile[$q]);
		my @array_out_2 = split(/\_/,$array_out_1[0]);
		$name_to_print[$q] = $array_out_2[0] . '_' . $array_out_2[1] . '_' . $array_out_2[2];
		while(<IN>)
		{
			$line =$_;
			chomp $line;
			@split_line = ();
			if($count > 0)
			{
				@split_line = split(/\t+/, $line);
				my $look = 0;
				my $find = 0;
				my $pos = 0;
				while($look < scalar(@organism_in))
				{
					if($organism_in[$look] eq $split_line[0])
					{
						$find += 1;
						$pos = $look;
						$look = scalar(@organism_in);
					}
					$look += 1;
				}
				if($find == 0)
				{
					$organism_in[$i] = $split_line[0];
					$j = 0;
					while($j < $q)
					{
						if($j == 0)
						{
							$counts_in[$i] = '0';
						}
						else
						{
							$counts_in[$i] .= ',0';
						}
						$j += 1;
					}
					$counts_in[$i] .= ',' . $split_line[1];
					$i += 1;
				}
				else
				{
					my @tocheck = ();
					@tocheck = split(/\,/, $counts_in[$pos]);	
					if(scalar(@tocheck) == $q)
					{
						$counts_in[$pos] .= ',' . $split_line[1];
					}
					elsif(scalar(@tocheck) <= ($q - 1))
					{
						my $counter = ($q - (scalar(@tocheck)));
						$w = 0;
						while($w < $counter)
						{
							$counts_in[$pos] .= ',0';
							$w += 1;
						}
						$counts_in[$pos] .= ',' . $split_line[1];
					}	
				}

			}
			$count += 1;
		}
	}
 	$q += 1;
}
$q = 0;
print OUT "name";
while($q < scalar(@name_to_print))
{
	print OUT "\t" . $name_to_print[$q];
	$q += 1;
}
print OUT "\n";
$q = 0;		
while($q < scalar(@organism_in))
{
	print OUT $organism_in[$q];
	my @split_to_print = ();
	@split_to_print = split(/\,/,$counts_in[$q]);
	$j = 0;
	while($j < scalar(@split_to_print))
	{
		print OUT "\t" . $split_to_print[$j];
		$j += 1;
	}
	if(scalar(@split_to_print) < scalar(@infile))
	{
		$i = scalar(@split_to_print);
		while($i < scalar(@infile))
		{
			print OUT "\t0";
			$i += 1;
		}
	}
	print OUT "\n";
	$q += 1;
}	
exit;


